<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true" label-width="90px">
            <el-form-item label="监控点名称" prop="pointName">
              <el-input v-model="queryParams.pointName" placeholder="请输入监控点名称" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="场景类型" prop="sceneType">
              <el-select v-model="queryParams.sceneType" placeholder="请选择场景类型" clearable>
                <el-option v-for="dict in scene_type" :key="dict.value" :label="dict.label" :value="dict.value" />
              </el-select>
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
              <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <!-- <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['manage:monitorPoint:add']">新增</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate()" v-hasPermi="['manage:monitorPoint:edit']"
              >修改</el-button
            >
          </el-col> -->
          <el-col :span="1.5">
            <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete()" v-hasPermi="['manage:monitorPoint:remove']"
              >删除</el-button
            >
          </el-col>
          <el-col :span="1.5">
            <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['manage:monitorPoint:export']">导出</el-button>
          </el-col>
          <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>
      </template>

      <el-table v-loading="loading" :data="monitorPointList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="监控点名称" align="center" width="150" show-overflow-tooltip prop="pointName" />
        <el-table-column label="行政区域" align="center" width="150" show-overflow-tooltip prop="areaName" />
        <el-table-column label="场景类型" align="center" prop="sceneType">
          <template #default="scope">
            <dict-tag :options="scene_type" :value="scope.row.sceneType" />
          </template>
        </el-table-column>
        <el-table-column label="经度" align="center" width="170" prop="longitude" />
        <el-table-column label="纬度" align="center" width="170" prop="latitude" />
        <el-table-column label="方向" align="center" prop="direction" />
        <el-table-column label="路口编号" align="center" prop="intersectionId" />
        <el-table-column label="操作" align="center" fixed="right" class-name="small-padding fixed-width">
          <template #default="scope">
            <!-- <el-tooltip content="修改" placement="top">
              <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['manage:monitorPoint:edit']"></el-button>
            </el-tooltip> -->
            <el-tooltip content="删除" placement="top">
              <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['manage:monitorPoint:remove']"></el-button>
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改监控点位信息对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="monitorPointFormRef" :model="form" :rules="rules" label-width="80px"> </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="MonitorPoint" lang="ts">
import { listMonitorPoint, getMonitorPoint, delMonitorPoint, addMonitorPoint, updateMonitorPoint } from '@/api/manage/monitorPoint';
import { MonitorPointVO, MonitorPointQuery, MonitorPointForm } from '@/api/manage/monitorPoint/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const { scene_type } = toRefs<any>(proxy?.useDict('scene_type'));

const monitorPointList = ref<MonitorPointVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const monitorPointFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: MonitorPointForm = {
}
const data = reactive<PageData<MonitorPointForm, MonitorPointQuery>>({
  form: {...initFormData},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    pointName: undefined,
    sceneType: undefined,
    params: {
    }
  },
  rules: {
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询监控点位信息列表 */
const getList = async () => {
  loading.value = true;
  const res = await listMonitorPoint(queryParams.value);
  monitorPointList.value = res.rows;
  total.value = res.total;
  loading.value = false;
}

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
}

/** 表单重置 */
const reset = () => {
  form.value = {...initFormData};
  monitorPointFormRef.value?.resetFields();
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
}

/** 多选框选中数据 */
const handleSelectionChange = (selection: MonitorPointVO[]) => {
  ids.value = selection.map(item => item.pointId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = "添加监控点位信息";
}

/** 修改按钮操作 */
const handleUpdate = async (row?: MonitorPointVO) => {
  reset();
  const _pointId = row?.pointId || ids.value[0]
  const res = await getMonitorPoint(_pointId);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = "修改监控点位信息";
}

/** 提交按钮 */
const submitForm = () => {
  monitorPointFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.pointId) {
        await updateMonitorPoint(form.value).finally(() =>  buttonLoading.value = false);
      } else {
        await addMonitorPoint(form.value).finally(() =>  buttonLoading.value = false);
      }
      proxy?.$modal.msgSuccess("操作成功");
      dialog.visible = false;
      await getList();
    }
  });
}

/** 删除按钮操作 */
const handleDelete = async (row?: MonitorPointVO) => {
  const _pointIds = row?.pointId || ids.value;
  await proxy?.$modal.confirm('是否确认删除监控点位信息？').finally(() => loading.value = false);
  await delMonitorPoint(_pointIds);
  proxy?.$modal.msgSuccess("删除成功");
  await getList();
}

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download('manage/monitorPoint/export', {
    ...queryParams.value
  }, `monitorPoint_${new Date().getTime()}.xlsx`)
}

onMounted(() => {
  getList();
});
</script>
